/* CS6 - Channel Services src/check_ban.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include <bot.h>

void enforce_chan_bans(char *chan)
{
   struct regsinfo *regs;
   struct nickinfo *nick;
   struct chaninfo *chans;
   struct baninfo *ban;
   char *nnick = NULL, uhost[1000], *newuser = NULL;

   regs = regshead;
   while(regs != NULL)
   {
      if(!strcasecmp(chan, regs->channel))
      {
         nick = nickhead;
         while(nick != NULL)
         {
            chans = nick->chanhead;
            while(chans != NULL)
            {
               if(!strcasecmp(chan, chans->channel))
               {
                  newuser = nick->user;
                  if(newuser[0] == '~')
                  {
                     newuser++;
                  }
                  sprintf(uhost, "%s!%s@%s", nick->nick, newuser, nick->host);
               	  ban = regs->banhead;
	          while(ban != NULL)
	          {
	             if(!wcmp(ban->ban, uhost) && ban->botban)
	             {
	                send_to_server(":%s MODE %s +b %s\n", bot.nick, chan, ban->ban);
	                send_to_server(":%s KICK %s %s :%s\n", bot.nick, chan, nick->numeric, "Enforcing Current Bans");
	                return;
	             }
	             ban = ban->next;
                  }
               }
               chans = chans->next;
            }
            nick = nick->next;
	 }
      }
      regs = regs->next;
   }
   return;
}

void enforce_ban(char *chan, char *nick)
{
   struct regsinfo *regs;
   struct baninfo *ban;
   char *nnick = NULL, *uhost = NULL;

   uhost = getnickuserhost(nick);
   if(uhost == NULL) return;
   nnick = nick2num(nick);
   regs = regshead;
   while(regs != NULL)
   {
      if(!strcasecmp(chan, regs->channel))
      {
	 ban = regs->banhead;
	 while(ban != NULL)
	 {
	    if(!wcmp(ban->ban, uhost) && ban->botban)
	    {
	       send_to_server(":%s MODE %s +b %s\n", bot.nick, chan, ban->ban);
	       send_to_server(":%s KICK %s %s :%s\n", bot.nick, chan, nnick, "Enforcing Current Bans");
	       return;
	    }
	    ban = ban->next;
	 }
      }
      regs = regs->next;
   }
   return;
}

void check_single_ban_time(char *chan)
{
   struct regsinfo *regs;
   struct baninfo *ban;
   struct nickinfo *nicks;
   struct chaninfo *chans;
   char newban[1000], mban[1000];
   int gotit = 0;

   newban[0] = '\0'; 
   mban[0] = '\0';
   regs = regshead;
   while(regs != NULL)
   {
      if(!strcasecmp(regs->channel, chan))
      {
	 ban = regs->banhead;
	 while(ban != NULL)
	 {
	    if(!ban->botban && regs->banmove != -1)
	    {
	       if(regs->banmove == 0 || time(NULL) >= regs->banmove + ban->timeset)
	       {
		  ban->timeset  = time(NULL);
		  ban->level = regs->banlvl;
		  ban->duration = regs->bantimeout;
		  strcpy(ban->reason, "Moved from Channel Ban Listing");
		  strcpy(ban->nick, bot.nick);
		  ban->botban = 1;
		  send_to_server(":%s MODE %s -b %s\n", bot.nick, regs->channel, ban->ban);
	       }
	    }
	    else if(!ban->botban && regs->banremove != 0)
	    {
	       if(time(NULL) >= regs->banremove + ban->timeset)
	       {
		  newban[0] = '\0';
		  strcpy(newban, ban->ban);
		  send_to_server(":%s MODE %s -b %s\n", bot.nick, regs->channel, ban->ban);
		  gotit = 1;
	       }
	    }
	    else if(ban->duration > 0 && ban->botban && (time(NULL) >= ban->timeset + ban->duration))
	    {
	       send_to_server(":%s MODE %s -b %s\n", bot.nick, regs->channel, ban->ban);
	       newban[0] = '\0';
	       strcpy(newban, ban->ban);
	       gotit = 1;
	    }
	    ban = ban->next;
	    if(gotit > 0)
	    {
	       delete_bnode(regs->channel, newban);
	       write_single_banfile(regs->channel);
	       gotit = 0;
	    }
	 }
      }
      regs = regs->next;
   }
}

void check_ban_times()
{
   struct regsinfo *regs;
   struct baninfo *ban;
   struct nickinfo *nicks;
   struct chaninfo *chans;
   char newban[1000];
   int gotit = 0;

   newban[0] = '\0';
   regs = regshead;
   while(regs != NULL)
   {
      ban = regs->banhead;
      while(ban != NULL)
      {
	 if(!ban->botban && regs->banmove != -1)
	 {
	    if(regs->banmove == 0 || time(NULL) >= regs->banmove + ban->timeset)
	    {
	       ban->timeset  = time(NULL);
	       ban->level = regs->banlvl;
	       ban->duration = regs->bantimeout;
	       strcpy(ban->reason, "Moved from Channel Ban Listing");
	       strcpy(ban->nick, bot.nick);
	       ban->botban = 1;
	       send_to_server(":%s MODE %s -b %s\n", bot.nick, regs->channel, ban->ban);
	    }
	 }
	 else if(!ban->botban && regs->banremove != 0)
	 {
	    if(time(NULL) >= regs->banremove + ban->timeset)
	    {
	       newban[0] = '\0';
	       strcpy(newban, ban->ban);
	       send_to_server(":%s MODE %s -b %s\n", bot.nick, regs->channel, ban->ban);
	       gotit = 1;
	    }
	 }
	 else if(ban->duration > 0 && ban->botban && (time(NULL) >= ban->timeset + ban->duration))
	 {
	    newban[0] = '\0';
	    strcpy(newban, ban->ban);
	    send_to_server(":%s MODE %s -b %s\n", bot.nick, regs->channel, ban->ban);
	    gotit = 1;
	 }
	 ban = ban->next;
	 if(gotit == 1)
	 {
	    delete_bnode(regs->channel, newban);
	    write_single_banfile(regs->channel);
	    gotit = 0;
	 }
      }
      regs = regs->next;
   }
}
