/* CS6 - Channel Services src/free_lists.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include <bot.h>

void delete_all_mail()
{
   struct mailinfo *current, *tmp;
   struct suppinfo *supp, *tmp1;

   log(ERRLOG_FILE, "[%s] Freeing maillist\n", date());
   current = mailhead;
   while(current != NULL)
   {
      supp = current->supphead;
      while(supp != NULL)
      {
	 if(supp == current->supphead) current->supphead = current->supphead->next;
	 tmp1 = supp->next;
	 free(supp);
	 supp=tmp1;
      }
      if(current == mailhead) mailhead = mailhead->next;
      tmp = current->next;
      free(current);
      current=tmp;
   }
}

void free_maplist()
{
   struct mapinfo *current, *tmp;
   log(ERRLOG_FILE, "[%s] Freeing Maplist\n", date());
   current = maphead;
   while(current != NULL)
   {
      if(current == maphead) maphead = maphead->next;
      tmp = current->next;
      free(current);
      current=tmp;
   }
}

void free_burst()
{
   struct burstinfo *current, *tmp;
   log(ERRLOG_FILE, "[%s] Freeing Burst\n", date());
   current = bursthead;
   while(current != NULL)
   {
      if(current == bursthead) bursthead = bursthead->next;
      tmp = current->next;
      free(current);
      current=tmp;
   }
}

void free_hublist()
{
   struct hubinfo *current, *tmp;
   log(ERRLOG_FILE, "[%s] Freeing Hublist\n", date());
   current = hubhead;
   while(current != NULL)
   {
      if(current == hubhead) hubhead = hubhead->next;
      tmp = current->next;
      free(current);
      current=tmp;
   }
}

void free_banlist(char *channel)
{
   struct regsinfo *regs, *tmp;
   struct baninfo *ban, *tmp2;

   log(ERRLOG_FILE, "[%s] Freeing %s banlist\n", date(), channel);
   regs = regshead;
   while(regs != NULL)
   {
      if(strcasecmp(regs->channel , channel))
      {
	 ban = regs->banhead;
	 while(ban != NULL && ban->botban)
	 {
	    if(ban == regs->banhead) regs->banhead = regs->banhead->next;
	    tmp2 = ban->next;
	    free(ban);
	    ban=tmp2;
	 }
      }
      regs = regs->next;
   }
}

void free_regslist()
{
   struct regsinfo *regs, *tmp;
   struct userinfo *user, *tmp1;
   struct baninfo *ban, *tmp2;
   struct cussinfo *cuss, *tmp3;

   log(ERRLOG_FILE, "[%s] Freeing regslist\n", date());
   regs = regshead;
   while(regs != NULL)
   {
      ban = regs->banhead;
      while(ban != NULL)
      {
	 if(ban == regs->banhead) regs->banhead = regs->banhead->next;
	 tmp2 = ban->next;
	 free(ban);
	 ban=tmp2;
      }
      cuss = regs->cusshead;
      while(cuss != NULL)
      {
	 if(cuss == regs->cusshead) regs->cusshead = regs->cusshead->next;
	 tmp3 = cuss->next;
	 free(cuss);
	 cuss=tmp3;
      }
      user = regs->userhead;
      while(user != NULL)
      {
	 if(user == regs->userhead) regs->userhead = regs->userhead->next;
	 tmp1 = user->next;
	 free(user);
	 user=tmp1;
      }
      if(regs == regshead) regshead = regshead->next;
      tmp = regs->next;
      free(regs);
      regs=tmp;
   }
}

void free_nicklist()
{
   struct nickinfo *nick, *tmp;
   struct chaninfo *chan, *tmp1;
   struct authinfo *auth, *tmp2;
   log(ERRLOG_FILE, "[%s] Freeing nicklist\n", date());
   nick = nickhead;
   while(nick != NULL)
   {
      chan = nick->chanhead;
      while(chan != NULL)
      {
	 if(chan == nick->chanhead) nick->chanhead = nick->chanhead->next;
	 tmp1 = chan->next;
	 free(chan);
	 chan=tmp1;
      }
      auth = nick->authhead;
      while(auth != NULL)
      {
	 if(auth == nick->authhead) nick->authhead = nick->authhead->next;
	 tmp2 = auth->next;
	 free(auth);
	 auth=tmp2;
      }
      if(nick == nickhead) nickhead = nickhead->next;
      tmp = nick->next;
      free(nick);
      nick=tmp;
   }
}
